//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Fibonacci colors";
extern color UpperFiboColor = Magenta;
extern color MainFiboColor = Thistle;//Magenta;
extern color LowerFiboColor = Magenta;//Plum;//SlateBlue;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("FiboUp_W1");
   ObjectDelete("FiboDn_W1");
   ObjectDelete("FiboIn_W1");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(ObjectFind("FiboUp_W1") == -1)
		ObjectCreate("FiboUp_W1",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUp_W1",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUp_W1",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUp_W1",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUp_W1",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("FiboUp_W1",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUp_W1",OBJPROP_FIBOLEVELS,13);
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboUp_W1",0,"(100.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+1,0.236);	   ObjectSetFiboDescription("FiboUp_W1",1,"(123.6%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+2,0.382);	   ObjectSetFiboDescription("FiboUp_W1",2,"(138.2%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+3,0.500);	   ObjectSetFiboDescription("FiboUp_W1",3,"(150.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+4,0.618);	   ObjectSetFiboDescription("FiboUp_W1",4,"(161.8%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+5,0.764);	   ObjectSetFiboDescription("FiboUp_W1",5,"(176.4%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+6,1.000);	   ObjectSetFiboDescription("FiboUp_W1",6,"(200.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+7,1.236);	   ObjectSetFiboDescription("FiboUp_W1",7,"(223.6%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+8,1.500);	   ObjectSetFiboDescription("FiboUp_W1",8,"(250.0%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+9,1.618);	   ObjectSetFiboDescription("FiboUp_W1",9,"(261.8%) -  %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUp_W1",10,"(300.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUp_W1",11,"(350.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUp_W1",12,"(400.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUp_W1",13,"(450.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUp_W1",14,"(500.0%) - %$"); 
   ObjectSet("FiboUp_W1",OBJPROP_RAY,true);
   ObjectSet("FiboUp_W1",OBJPROP_BACK,true);

	if(ObjectFind("FiboDn_W1") == -1)
		ObjectCreate("FiboDn_W1",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDn_W1",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDn_W1",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDn_W1",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDn_W1",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDn_W1",OBJPROP_LEVELCOLOR,LowerFiboColor); 
   ObjectSet("FiboDn_W1",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+0,0.0);	   ObjectSetFiboDescription("FiboDn_W1",0,"(0.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+1,0.236);	   ObjectSetFiboDescription("FiboDn_W1",1,"(-23.6%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+2,0.382);	   ObjectSetFiboDescription("FiboDn_W1",2,"(-38.2%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+3,0.500);	   ObjectSetFiboDescription("FiboDn_W1",3,"(-50.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+4,0.618);	   ObjectSetFiboDescription("FiboDn_W1",4,"(-61.8%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+5,0.764);	   ObjectSetFiboDescription("FiboDn_W1",5,"(-76.4%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+6,1.000);	   ObjectSetFiboDescription("FiboDn_W1",6,"(-100.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+7,1.236);	   ObjectSetFiboDescription("FiboDn_W1",7,"(-123.6%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+8,1.382);	   ObjectSetFiboDescription("FiboDn_W1",8,"(-138.2%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+9,1.500);	   ObjectSetFiboDescription("FiboDn_W1",9,"(-150.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDn_W1",10,"(-161.8%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDn_W1",11,"(-176.4%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDn_W1",12,"(-200.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDn_W1",13,"(-250.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDn_W1",14,"(-300.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDn_W1",15,"(-350.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDn_W1",16,"(-400.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDn_W1",17,"(-450.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDn_W1",18,"(-500.0%) -  %$"); 
   ObjectSet("FiboDn_W1",OBJPROP_RAY,true);
   ObjectSet("FiboDn_W1",OBJPROP_BACK,true);

	if(InnerFibs)
	{
		if(ObjectFind("FiboIn_W1") == -1)
			ObjectCreate("FiboIn_W1",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("FiboIn_W1",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboIn_W1",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("FiboIn_W1",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboIn_W1",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboIn_W1",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboIn_W1",0,"Weekly LOW (0.0) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboIn_W1",1,"(23.6) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboIn_W1",2,"(38.2) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboIn_W1",3,"(50.0) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboIn_W1",4,"(61.8) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboIn_W1",5,"(76.4) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboIn_W1",6,"Weekly HIGH (100.0) -  %$"); 
   	ObjectSet("FiboIn_W1",OBJPROP_RAY,true);
   	ObjectSet("FiboIn_W1",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboIn_W1");
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_W1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_W1,shift);
	LoPrice		= iLow (NULL,PERIOD_W1,shift);
	StartTime	= iTime(NULL,PERIOD_W1,shift);


	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

